std::basic_stringstream< _CharT, _Traits, _Alloc >(3cxx)

NAME
std::basic_stringstream< _CharT, _Traits, _Alloc > - Controlling input and output for std::string.

SYNOPSIS

#include <sstream>

Inherits std::basic_iostream< _CharT, _Traits >.

  Public Types

typedef ctype< _CharT > __ctype_type
typedef ctype< _CharT > __ctype_type
typedef basic_ios< _CharT, _Traits > __ios_type
typedef basic_ios< _CharT, _Traits > __ios_type
typedef basic_iostream< char_type, traits_type > __iostream_type
typedef basic_istream< _CharT, _Traits > __istream_type
typedef num_get< _CharT, istreambuf_iterator< _CharT, _Traits > > __num_get_type
typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > __num_put_type
typedef basic_ostream< _CharT, _Traits > __ostream_type
typedef basic_streambuf< _CharT, _Traits > __streambuf_type
typedef basic_streambuf< _CharT, _Traits > __streambuf_type
typedef basic_string< _CharT, _Traits, _Alloc > __string_type
typedef basic_stringbuf< _CharT, _Traits, _Alloc > __stringbuf_type
typedef _Alloc allocator_type
typedef _CharT char_type
enum event { erase_event, imbue_event, copyfmt_event }
The set of events that may be passed to an event callback.
typedef void(* event_callback) (event __e, ios_base &__b, int __i)
The type of an event callback function.
typedef _Ios_Fmtflags fmtflags
This is a bitmask type.
typedef traits_type::int_type int_type
typedef _Ios_Iostate iostate
This is a bitmask type.
typedef traits_type::off_type off_type
typedef _Ios_Openmode openmode
This is a bitmask type.
typedef traits_type::pos_type pos_type
typedef _Ios_Seekdir seekdir
This is an enumerated type.
typedef _Traits traits_type

typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > __num_put_type

  Public Member Functions

basic_stringstream ()
Default constructor starts with an empty string buffer.
basic_stringstream (basic_stringstream &&__rhs)
basic_stringstream (const __string_type &__str, ios_base::openmode __m=ios_base::out|ios_base::in)
Starts with an existing string buffer.
basic_stringstream (const basic_stringstream &)=delete
basic_stringstream (ios_base::openmode __m)
Starts with an empty string buffer.
~basic_stringstream ()
The destructor does nothing.
template<typename _ValueT > basic_istream< _CharT, _Traits > & _M_extract (_ValueT &__v)
const locale & _M_getloc () const
Locale access.
template<typename _ValueT > basic_ostream< _CharT, _Traits > & _M_insert (_ValueT __v)
void _M_setstate (iostate __state)
bool bad () const
Fast error checking.
void clear (iostate __state=goodbit)
[Re]sets the error state.
basic_ios & copyfmt (const basic_ios &__rhs)
Copies fields of __rhs into this.
bool eof () const
Fast error checking.
iostate exceptions () const
Throwing exceptions on errors.
void exceptions (iostate __except)
Throwing exceptions on errors.
bool fail () const
Fast error checking.
char_type fill () const
Retrieves the empty character.
char_type fill (char_type __ch)
Sets a new empty character.
fmtflags flags () const
Access to format flags.
fmtflags flags (fmtflags __fmtfl)
Setting new format flags all at once.
__ostream_type & flush ()
Synchronizing the stream buffer.
streamsize gcount () const
Character counting.
basic_istream< char > & getline (char_type *__s, streamsize __n, char_type __delim)
Explicit specialization declarations, defined in src/istream.cc.
basic_istream< wchar_t > & getline (char_type *__s, streamsize __n, char_type __delim)
locale getloc () const
Locale access.
bool good () const
Fast error checking.
basic_istream< char > & ignore (streamsize __n)
basic_istream< wchar_t > & ignore (streamsize __n)
basic_istream< char > & ignore (streamsize __n, int_type __delim)
basic_istream< wchar_t > & ignore (streamsize __n, int_type __delim)
locale imbue (const locale &__loc)
Moves to a new locale.
long & iword (int __ix)
Access to integer array.
char narrow (char_type __c, char __dfault) const
Squeezes characters.
__ostream_type & operator<< (__streambuf_type *__sb)
Extracting from another streambuf.
__ostream_type & operator<< (const void *__p)
Pointer arithmetic inserters.
__ostream_type & operator<< (nullptr_t)
basic_stringstream & operator= (basic_stringstream &&__rhs)
basic_stringstream & operator= (const basic_stringstream &)=delete
__istream_type & operator>> (__streambuf_type *__sb)
Extracting into another streambuf.
__istream_type & operator>> (void *&__p)
Basic arithmetic extractors.
streamsize precision () const
Flags access.
streamsize precision (streamsize __prec)
Changing flags.
void *& pword (int __ix)
Access to void pointer array.
__stringbuf_type * rdbuf () const
Accessing the underlying buffer.
basic_streambuf< _CharT, _Traits > * rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
Changing the underlying buffer.
iostate rdstate () const
Returns the error state of the stream buffer.
void register_callback (event_callback __fn, int __index)
Add the callback __fn with parameter __index.
__ostream_type & seekp (off_type, ios_base::seekdir)
Changing the current write position.
__ostream_type & seekp (pos_type)
Changing the current write position.
fmtflags setf (fmtflags __fmtfl)
Setting new format flags.
fmtflags setf (fmtflags __fmtfl, fmtflags __mask)
Setting new format flags.
void setstate (iostate __state)
Sets additional flags in the error state.
__string_type str () const
Copying out the string buffer.
void str (const __string_type &__s)
Setting a new buffer.
void swap (basic_stringstream &__rhs)
pos_type tellp ()
Getting the current write position.
basic_ostream< _CharT, _Traits > * tie () const
Fetches the current tied stream.
basic_ostream< _CharT, _Traits > * tie (basic_ostream< _CharT, _Traits > *__tiestr)
Ties this stream to an output stream.
void unsetf (fmtflags __mask)
Clearing format flags.
char_type widen (char __c) const
Widens characters.
streamsize width () const
Flags access.
streamsize width (streamsize __wide)
Changing flags.

__istream_type & operator>> (__istream_type &(*__pf)(__istream_type &))
Interface for manipulators.
__istream_type & operator>> (__ios_type &(*__pf)(__ios_type &))
Interface for manipulators.
__istream_type & operator>> (ios_base &(*__pf)(ios_base &))
Interface for manipulators.

Extractors
All the operator>> functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state (without causing an ios_base::failure to be thrown) and the original exception will be rethrown if badbit is set in the exceptions mask.

__istream_type & operator>> (bool &__n)
Integer arithmetic extractors.
__istream_type & operator>> (short &__n)
Integer arithmetic extractors.
__istream_type & operator>> (unsigned short &__n)
Integer arithmetic extractors.
__istream_type & operator>> (int &__n)
Integer arithmetic extractors.
__istream_type & operator>> (unsigned int &__n)
Integer arithmetic extractors.
__istream_type & operator>> (long &__n)
Integer arithmetic extractors.
__istream_type & operator>> (unsigned long &__n)
Integer arithmetic extractors.
__istream_type & operator>> (long long &__n)
Integer arithmetic extractors.
__istream_type & operator>> (unsigned long long &__n)
Integer arithmetic extractors.

__istream_type & operator>> (float &__f)
Floating point arithmetic extractors.
__istream_type & operator>> (double &__f)
Floating point arithmetic extractors.
__istream_type & operator>> (long double &__f)
Floating point arithmetic extractors.

Unformatted Input Functions
All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state (without causing an ios_base::failure to be thrown) and the original exception will be rethrown if badbit is set in the exceptions mask.

int_type get ()
Simple extraction.
__istream_type & get (char_type &__c)
Simple extraction.
__istream_type & get (char_type *__s, streamsize __n, char_type __delim)
Simple multiple-character extraction.
__istream_type & get (char_type *__s, streamsize __n)
Simple multiple-character extraction.
__istream_type & get (__streambuf_type &__sb, char_type __delim)
Extraction into another streambuf.
__istream_type & get (__streambuf_type &__sb)
Extraction into another streambuf.
__istream_type & getline (char_type *__s, streamsize __n, char_type __delim)
String extraction.
__istream_type & getline (char_type *__s, streamsize __n)
String extraction.
__istream_type & ignore (streamsize __n, int_type __delim)
Discarding characters.
__istream_type & ignore (streamsize __n)
Simple extraction.
__istream_type & ignore ()
Simple extraction.
int_type peek ()
Looking ahead in the stream.
__istream_type & read (char_type *__s, streamsize __n)
Extraction without delimiters.
streamsize readsome (char_type *__s, streamsize __n)
Extraction until the buffer is exhausted, but no more.
__istream_type & putback (char_type __c)
Unextracting a single character.
__istream_type & unget ()
Unextracting the previous character.
int sync ()
Synchronizing the stream buffer.
pos_type tellg ()
Getting the current read position.
__istream_type & seekg (pos_type)
Changing the current read position.
__istream_type & seekg (off_type, ios_base::seekdir)
Changing the current read position.

operator bool () const
The quick-and-easy status check.
bool operator! () const
The quick-and-easy status check.

__ostream_type & operator<< (__ostream_type &(*__pf)(__ostream_type &))
Interface for manipulators.
__ostream_type & operator<< (__ios_type &(*__pf)(__ios_type &))
Interface for manipulators.
__ostream_type & operator<< (ios_base &(*__pf)(ios_base &))
Interface for manipulators.

Inserters
All the operator<< functions (aka formatted output functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_ostream::sentry. This can have several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to generate whatever data is appropriate for the type of the argument.

If an exception is thrown during insertion, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__ostream_type & operator<< (long __n)
Integer arithmetic inserters.
__ostream_type & operator<< (unsigned long __n)
Integer arithmetic inserters.
__ostream_type & operator<< (bool __n)
Integer arithmetic inserters.
__ostream_type & operator<< (short __n)
Integer arithmetic inserters.
__ostream_type & operator<< (unsigned short __n)
Integer arithmetic inserters.
__ostream_type & operator<< (int __n)
Integer arithmetic inserters.
__ostream_type & operator<< (unsigned int __n)
Integer arithmetic inserters.
__ostream_type & operator<< (long long __n)
Integer arithmetic inserters.
__ostream_type & operator<< (unsigned long long __n)
Integer arithmetic inserters.

__ostream_type & operator<< (double __f)
Floating point arithmetic inserters.
__ostream_type & operator<< (float __f)
Floating point arithmetic inserters.
__ostream_type & operator<< (long double __f)
Floating point arithmetic inserters.

Unformatted Output Functions
All the unformatted output functions have some common behavior. Each starts by constructing a temporary object of type std::basic_ostream::sentry. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to generate whatever data is appropriate for the type of the argument.

If an exception is thrown during insertion, ios_base::badbit will be turned on in the stream's error state. If badbit is on in the stream's exceptions mask, the exception will be rethrown without completing its actions.

__ostream_type & put (char_type __c)
Simple insertion.
void _M_write (const char_type *__s, streamsize __n)
Core write functionality, without sentry.
__ostream_type & write (const char_type *__s, streamsize __n)
Character string insertion.

  Static Public Member Functions

static bool sync_with_stdio (bool __sync=true)
Interaction with the standard C I/O objects.
static int xalloc () throw ()
Access to unique indices.

  Static Public Attributes

static const fmtflags adjustfield
A mask of left|right|internal. Useful for the 2-arg form of setf.
static const openmode app
Seek to end before each write.
static const openmode ate
Open and seek to end immediately after opening.
static const iostate badbit
Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).
static const fmtflags basefield
A mask of dec|oct|hex. Useful for the 2-arg form of setf.
static const seekdir beg
Request a seek relative to the beginning of the stream.
static const openmode binary
Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary.
static const fmtflags boolalpha
Insert/extract bool in alphabetic rather than numeric format.
static const seekdir cur
Request a seek relative to the current position within the sequence.
static const fmtflags dec
Converts integer input or generates integer output in decimal base.
static const seekdir end
Request a seek relative to the current end of the sequence.
static const iostate eofbit
Indicates that an input operation reached the end of an input sequence.
static const iostate failbit
Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.
static const fmtflags fixed
Generate floating-point output in fixed-point notation.
static const fmtflags floatfield
A mask of scientific|fixed. Useful for the 2-arg form of setf.
static const iostate goodbit
Indicates all is well.
static const fmtflags hex
Converts integer input or generates integer output in hexadecimal base.
static const openmode in
Open for input. Default for ifstream and fstream.
static const fmtflags internal
Adds fill characters at a designated internal point in certain generated output, or identical to right if no such point is designated.
static const fmtflags left
Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.)
static const fmtflags oct
Converts integer input or generates integer output in octal base.
static const openmode out
Open for output. Default for ofstream and fstream.
static const fmtflags right
Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.)
static const fmtflags scientific
Generates floating-point output in scientific notation.
static const fmtflags showbase
Generates a prefix indicating the numeric base of generated integer output.
static const fmtflags showpoint
Generates a decimal-point character unconditionally in generated floating-point output.
static const fmtflags showpos
Generates a + sign in non-negative generated numeric output.
static const fmtflags skipws
Skips leading white space before certain input operations.
static const openmode trunc
Truncate an existing stream when opening. Default for ofstream.
static const fmtflags unitbuf
Flushes output after each output operation.
static const fmtflags uppercase
Replaces certain lowercase letters with their uppercase equivalents in generated output.

  Protected Types

enum { _S_local_word_size }

  Protected Member Functions

void _M_cache_locale (const locale &__loc)
void _M_call_callbacks (event __ev) throw ()
void _M_dispose_callbacks (void) throw ()
template<typename _ValueT > __istream_type & _M_extract (_ValueT &__v)
_Words & _M_grow_words (int __index, bool __iword)
void _M_init () throw ()
template<typename _ValueT > __ostream_type & _M_insert (_ValueT __v)
void _M_move (ios_base &) noexcept
void _M_swap (ios_base &__rhs) noexcept
void init (basic_streambuf< _CharT, _Traits > *__sb)
All setup is performed here.
void move (basic_ios &&__rhs)
void move (basic_ios &__rhs)
void set_rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
void swap (basic_ios &__rhs) noexcept
void swap (basic_iostream &__rhs)
void swap (basic_istream &__rhs)
void swap (basic_ostream &__rhs)

  Protected Attributes

_Callback_list * _M_callbacks
const __ctype_type * _M_ctype
iostate _M_exception
char_type _M_fill
bool _M_fill_init
fmtflags _M_flags
streamsize _M_gcount
locale _M_ios_locale
_Words _M_local_word [_S_local_word_size]
const __num_get_type * _M_num_get
const __num_put_type * _M_num_put
streamsize _M_precision
basic_streambuf< _CharT, _Traits > * _M_streambuf
iostate _M_streambuf_state
basic_ostream< _CharT, _Traits > * _M_tie
streamsize _M_width
_Words * _M_word
int _M_word_size
_Words _M_word_zero

Detailed Description

  template<typename _CharT, typename _Traits, typename _Alloc>
class std::basic_stringstream< _CharT, _Traits, _Alloc >"Controlling input and output for std::string.

Template Parameters
    _CharT Type of character stream.
    _Traits Traits for character type, defaults to char_traits<_CharT>.
    _Alloc Allocator type, defaults to allocator<_CharT>.

This class supports reading from and writing to objects of type std::basic_string, using the inherited functions from std::basic_iostream. To control the associated sequence, an instance of std::basic_stringbuf is used, which this page refers to as sb.

Member Typedef Documentation

  template<typename _CharT , typename _Traits > typedef num_put<_CharT, ostreambuf_iterator<_CharT, _Traits> > std::basic_ios< _CharT, _Traits >::__num_put_type [inherited]
These are non-standard types.

  typedef void(* std::ios_base::event_callback) (event __e, ios_base &__b, int __i) [inherited]

The type of an event callback function.

Parameters
    __e One of the members of the event enum.
    __b Reference to the ios_base object.
    __i The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

  typedef _Ios_Fmtflags std::ios_base::fmtflags [inherited]

This is a bitmask type. _Ios_Fmtflags is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

•   boolalpha

•   dec

•   fixed

•   hex

•   internal

•   left

•   oct

•   right

•   scientific

•   showbase

•   showpoint

•   showpos

•   skipws

•   unitbuf

•   uppercase

•   adjustfield

•   basefield

•   floatfield

  typedef _Ios_Iostate std::ios_base::iostate [inherited]

This is a bitmask type. _Ios_Iostate is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

•   badbit

•   eofbit

•   failbit

•   goodbit

  typedef _Ios_Openmode std::ios_base::openmode [inherited]

This is a bitmask type. _Ios_Openmode is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

•   app

•   ate

•   binary

•   in

•   out

•   trunc

  typedef _Ios_Seekdir std::ios_base::seekdir [inherited]

This is an enumerated type. _Ios_Seekdir is implementation-defined. Defined values of type seekdir are:

•   beg

•   cur, equivalent to SEEK_CUR in the C standard library.

•   end, equivalent to SEEK_END in the C standard library.

Member Enumeration Documentation

  enum std::ios_base::event [inherited]

The set of events that may be passed to an event callback. erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Constructor & Destructor Documentation

  template<typename _CharT , typename _Traits , typename _Alloc > std::basic_stringstream< _CharT, _Traits, _Alloc >::basic_stringstream () [inline]

Default constructor starts with an empty string buffer. Initializes sb using the mode in|out, and passes &sb to the base class initializer. Does not allocate any buffer.

That's a lie. We initialize the base class with NULL, because the string class does its own memory management.

  template<typename _CharT , typename _Traits , typename _Alloc > std::basic_stringstream< _CharT, _Traits, _Alloc >::basic_stringstream (ios_base::openmode __m) [inline], [explicit]

Starts with an empty string buffer.

Parameters
    __m Whether the buffer can read, or write, or both.

Initializes sb using the mode from __m, and passes &sb to the base class initializer. Does not allocate any buffer.

That's a lie. We initialize the base class with NULL, because the string class does its own memory management.

  template<typename _CharT , typename _Traits , typename _Alloc > std::basic_stringstream< _CharT, _Traits, _Alloc >::basic_stringstream (const __string_type & __str, ios_base::openmode __m = ios_base::out | ios_base::in) [inline], [explicit]

Starts with an existing string buffer.

Parameters
    __str A string to copy as a starting buffer.
    __m Whether the buffer can read, or write, or both.

Initializes sb using __str and __m, and passes &sb to the base class initializer.

That's a lie. We initialize the base class with NULL, because the string class does its own memory management.

  template<typename _CharT , typename _Traits , typename _Alloc > std::basic_stringstream< _CharT, _Traits, _Alloc >::~basic_stringstream () [inline]

The destructor does nothing. The buffer is deallocated by the stringbuf object, not the formatting stream.

Member Function Documentation

  const locale & std::ios_base::_M_getloc () const [inline], [inherited]

Locale access.

Returns
    A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

  template<typename _CharT , typename _Traits > void std::basic_ostream< _CharT, _Traits >::_M_write (const char_type * __s, streamsize __n) [inline], [inherited]

Core write functionality, without sentry.

Parameters
    __s The array to insert.
    __n Maximum number of characters to insert.

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::bad () const [inline], [inherited]

Fast error checking.

Returns
    True if the badbit is set.

Note that other iostate flags may also be set.

References std::ios_base::badbit, and std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::clear (iostate __state = goodbit) [inherited]

[Re]sets the error state.

Parameters
    __state The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Referenced by std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ios< _CharT, _Traits >::setstate(), and std::basic_istream< _CharT, _Traits >::unget().

  template<typename _CharT , typename _Traits > basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt (const basic_ios< _CharT, _Traits > & __rhs) [inherited]

Copies fields of __rhs into this.

Parameters
    __rhs The source values for the copies.

Returns
    Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

References std::basic_ios< _CharT, _Traits >::tie(), and std::tie().

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::eof () const [inline], [inherited]

Fast error checking.

Returns
    True if the eofbit is set.

Note that other iostate flags may also be set.

References std::ios_base::eofbit, and std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > iostate std::basic_ios< _CharT, _Traits >::exceptions () const [inline], [inherited]

Throwing exceptions on errors.

Returns
    The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::exceptions (iostate __except) [inline], [inherited]

Throwing exceptions on errors.

Parameters
    __except The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flag is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

#include <iostream>
#include <fstream>
#include <exception>

int main()
{
    std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

    std::ifstream f ("/etc/motd");

    std::cerr << "Setting badbit\n";
    f.setstate (std::ios_base::badbit);

    std::cerr << "Setting exception mask\n";
    f.exceptions (std::ios_base::badbit);
}

References std::basic_ios< _CharT, _Traits >::clear().

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::fail () const [inline], [inherited]

Fast error checking.

Returns
    True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

References std::ios_base::badbit, std::ios_base::failbit, and std::basic_ios< _CharT, _Traits >::rdstate().

Referenced by std::basic_ios< _CharT, _Traits >::operator bool(), std::basic_ios< _CharT, _Traits >::operator!(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

  template<typename _CharT , typename _Traits > char_type std::basic_ios< _CharT, _Traits >::fill () const [inline], [inherited]

Retrieves the empty character.

Returns
    The current fill character.

It defaults to a space (' ') in the current locale.

References std::basic_ios< _CharT, _Traits >::widen().

Referenced by std::basic_ios< _CharT, _Traits >::fill().

  template<typename _CharT , typename _Traits > char_type std::basic_ios< _CharT, _Traits >::fill (char_type __ch) [inline], [inherited]

Sets a new empty character.

Parameters
    __ch The new character.

Returns
    The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

References std::basic_ios< _CharT, _Traits >::fill().

  fmtflags std::ios_base::flags () const [inline], [inherited]

Access to format flags.

Returns
    The format control flags for both input and output.

  fmtflags std::ios_base::flags (fmtflags __fmtfl) [inline], [inherited]

Setting new format flags all at once.

Parameters
    __fmtfl The new flags to set.

Returns
    The previous format control flags.

This function overwrites all the format flags with __fmtfl.

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::flush () [inherited]

Synchronizing the stream buffer.

Returns
    *this

If rdbuf() is a null pointer, changes nothing.

Otherwise, calls rdbuf()->pubsync(), and if that returns -1, sets badbit.

References std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > streamsize std::basic_istream< _CharT, _Traits >::gcount () const [inline], [inherited]

Character counting.

Returns
    The number of characters extracted by the previous unformatted input function dispatched for this stream.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::get (void) [inherited]

Simple extraction.

Returns
    A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::get (__streambuf_type & __sb) [inline], [inherited]

Extraction into another streambuf.

Parameters
    __sb A streambuf in which to store data.

Returns
    *this

Returns get(__sb,widen('\n')).

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get (__streambuf_type & __sb, char_type __delim) [inherited]

Extraction into another streambuf.

Parameters
    __sb A streambuf in which to store data.
    __delim A 'stop' character.

Returns
    *this

Characters are extracted and inserted into __sb until one of the following happens:

•   the input sequence reaches EOF

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)

•   the next character equals __delim (in this case, the character is not extracted)

•   an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get (char_type & __c) [inherited]

Simple extraction.

Parameters
    __c The character in which to store data.

Returns
    *this

Tries to extract a character and store it in __c. If none are available, sets failbit and returns traits::eof().

Note
    This function is not overloaded on signed char and unsigned char.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::get (char_type * __s, streamsize __n) [inline], [inherited]

Simple multiple-character extraction.

Parameters
    __s Pointer to an array.
    __n Maximum number of characters to store in s.

Returns
    *this

Returns get(__s,__n,widen('\n')).

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get (char_type * __s, streamsize __n, char_type __delim) [inherited]

Simple multiple-character extraction.

Parameters
    __s Pointer to an array.
    __n Maximum number of characters to store in __s.
    __delim A 'stop' character.

Returns
    *this

Characters are extracted and stored into __s until one of the following happens:

•   __n-1 characters are stored

•   the input sequence reaches EOF

•   the next character equals __delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note
    This function is not overloaded on signed char and unsigned char.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::eofbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::getline (char_type * __s, streamsize __n) [inline], [inherited]

String extraction.

Parameters
    __s A character array in which to store the data.
    __n Maximum number of characters to extract.

Returns
    *this

Returns getline(__s,__n,widen('\n')).

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::getline (char_type * __s, streamsize __n, char_type __delim) [inherited]

String extraction.

Parameters
    __s A character array in which to store the data.
    __n Maximum number of characters to extract.
    __delim A 'stop' character.

Returns
    *this

Extracts and stores characters into __s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the __s array without setting failbit.

1.  the input sequence reaches end-of-file, in which case eofbit is set in the stream error state

2.  the next character equals __delim, in which case the character is extracted (and therefore counted in gcount()) but not stored

3.  __n-1 characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

  basic_istream< char > & std::basic_istream< char >::getline (char_type * __s, streamsize __n, char_type __delim) [inherited]

Explicit specialization declarations, defined in src/istream.cc.

  locale std::ios_base::getloc () const [inline], [inherited]

Locale access.

Returns
    A copy of the current locale.

If imbue(loc) has previously been called, then this function returns loc. Otherwise, it returns a copy of std::locale(), the global C++ locale.

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::good () const [inline], [inherited]

Fast error checking.

Returns
    True if no error flags are set.

A wrapper around rdstate.

References std::basic_ios< _CharT, _Traits >::rdstate().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore (void) [inherited]

Simple extraction.

Returns
    A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore (streamsize __n) [inherited]

Simple extraction.

Returns
    A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore (streamsize __n, int_type __delim) [inherited]

Discarding characters.

Parameters
    __n Number of characters to discard.
    __delim A 'stop' character.

Returns
    *this

Extracts characters and throws them away until one of the following happens:

•   if __n != std::numeric_limits<int>::max(), __n characters are extracted

•   the input sequence reaches end-of-file

•   the next character equals __delim (in this case, the character is extracted); note that this condition will never occur if __delim equals traits::eof().

NB: Provide three overloads, instead of the single function (with defaults) mandated by the Standard: this leads to a better performing implementation, while still conforming to the Standard.

References std::basic_istream< _CharT, _Traits >::_M_gcount, and std::ios_base::goodbit.

  template<typename _CharT , typename _Traits > locale std::basic_ios< _CharT, _Traits >::imbue (const locale & __loc) [inherited]

Moves to a new locale.

Parameters
    __loc The new locale.

Returns
    The previous locale.

Calls ios_base::imbue(loc), and if a stream buffer is associated with this stream, calls that buffer's pubimbue(loc).

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

References std::ios_base::imbue().

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::init (basic_streambuf< _CharT, _Traits > * __sb) [protected], [inherited]

All setup is performed here. This is called from the public constructor. It is not virtual and cannot be redefined.

Referenced by std::basic_ios< _CharT, _Traits >::basic_ios().

  long & std::ios_base::iword (int __ix) [inline], [inherited]

Access to integer array.

Parameters
    __ix Index into the array.

Returns
    A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

  template<typename _CharT , typename _Traits > char std::basic_ios< _CharT, _Traits >::narrow (char_type __c, char __dfault) const [inline], [inherited]

Squeezes characters.

Parameters
    __c The character to narrow.
    __dfault The character to narrow.

Returns
    The narrowed character.

Maps a character of char_type to a character of char, if possible.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

  template<typename _CharT , typename _Traits > std::basic_ios< _CharT, _Traits >::operator bool () const [inline], [explicit], [inherited]

The quick-and-easy status check. This allows you to write constructs such as if (!a_stream) ... and while (a_stream) ...

References std::basic_ios< _CharT, _Traits >::fail().

  template<typename _CharT , typename _Traits > bool std::basic_ios< _CharT, _Traits >::operator! () const [inline], [inherited]

The quick-and-easy status check. This allows you to write constructs such as if (!a_stream) ... and while (a_stream) ...

References std::basic_ios< _CharT, _Traits >::fail().

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (__ios_type &(*)(__ios_type &) __pf) [inline], [inherited]

Interface for manipulators. Manipulators such as std::endl and std::hex use these functions in constructs like 'std::cout << std::endl'. For more information, see the iomanip header.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (__ostream_type &(*)(__ostream_type &) __pf) [inline], [inherited]

Interface for manipulators. Manipulators such as std::endl and std::hex use these functions in constructs like 'std::cout << std::endl'. For more information, see the iomanip header.

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::operator<< (__streambuf_type * __sb) [inherited]

Extracting from another streambuf.

Parameters
    __sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If __sb is NULL, the stream will set failbit in its error state.

Characters are extracted from __sb and inserted into *this until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs while getting a character from __sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (bool __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (const void * __p) [inline], [inherited]

Pointer arithmetic inserters.

Parameters
    __p A variable of pointer type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (double __f) [inline], [inherited]

Floating point arithmetic inserters.

Parameters
    __f A variable of builtin floating point type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (float __f) [inline], [inherited]

Floating point arithmetic inserters.

Parameters
    __f A variable of builtin floating point type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::operator<< (int __n) [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (ios_base &(*)(ios_base &) __pf) [inline], [inherited]

Interface for manipulators. Manipulators such as std::endl and std::hex use these functions in constructs like 'std::cout << std::endl'. For more information, see the iomanip header.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (long __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (long double __f) [inline], [inherited]

Floating point arithmetic inserters.

Parameters
    __f A variable of builtin floating point type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (long long __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::operator<< (short __n) [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

References std::ios_base::badbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (unsigned int __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (unsigned long __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (unsigned long long __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __ostream_type & std::basic_ostream< _CharT, _Traits >::operator<< (unsigned short __n) [inline], [inherited]

Integer arithmetic inserters.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to perform numeric formatting.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (__ios_type &(*)(__ios_type &) __pf) [inline], [inherited]

Interface for manipulators. Manipulators such as std::ws and std::dec use these functions in constructs like std::cin >> std::ws. For more information, see the iomanip header.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (__istream_type &(*)(__istream_type &) __pf) [inline], [inherited]

Interface for manipulators. Manipulators such as std::ws and std::dec use these functions in constructs like std::cin >> std::ws. For more information, see the iomanip header.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> (__streambuf_type * __sb) [inherited]

Extracting into another streambuf.

Parameters
    __sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If __sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the __sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

References std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (bool & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (double & __f) [inline], [inherited]

Floating point arithmetic extractors.

Parameters
    __f A variable of builtin floating point type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (float & __f) [inline], [inherited]

Floating point arithmetic extractors.

Parameters
    __f A variable of builtin floating point type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> (int & __n) [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (ios_base &(*)(ios_base &) __pf) [inline], [inherited]

Interface for manipulators. Manipulators such as std::ws and std::dec use these functions in constructs like std::cin >> std::ws. For more information, see the iomanip header.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (long & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (long double & __f) [inline], [inherited]

Floating point arithmetic extractors.

Parameters
    __f A variable of builtin floating point type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (long long & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> (short & __n) [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

References std::ios_base::badbit, std::ios_base::failbit, std::ios_base::goodbit, and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (unsigned int & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (unsigned long & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (unsigned long long & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (unsigned short & __n) [inline], [inherited]

Integer arithmetic extractors.

Parameters
    __n A variable of builtin integral type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > __istream_type & std::basic_istream< _CharT, _Traits >::operator>> (void *& __p) [inline], [inherited]

Basic arithmetic extractors.

Parameters
    __p A variable of pointer type.

Returns
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::peek (void) [inherited]

Looking ahead in the stream.

Returns
    The next character, or eof().

If, after constructing the sentry object, good() is false, returns traits::eof(). Otherwise reads but does not extract the next input character.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  streamsize std::ios_base::precision () const [inline], [inherited]

Flags access.

Returns
    The precision to generate on certain output operations.

Be careful if you try to give a definition of precision here; see DR 189.

  streamsize std::ios_base::precision (streamsize __prec) [inline], [inherited]

Changing flags.

Parameters
    __prec The new precision value.

Returns
    The previous value of precision().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::put (char_type __c) [inherited]

Simple insertion.

Parameters
    __c The character to insert.

Returns
    *this

Tries to insert __c.

Note
    This function is not overloaded on signed char and unsigned char.

References std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::putback (char_type __c) [inherited]

Unextracting a single character.

Parameters
    __c The character to push back into the input stream.

Returns
    *this

If rdbuf() is not null, calls rdbuf()->sputbackc(c).

If rdbuf() is null or if sputbackc() fails, sets badbit in the error state.

Note
    This function first clears eofbit. Since no characters are extracted, the next call to gcount() will return 0, as required by DR 60.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), and std::basic_ios< _CharT, _Traits >::setstate().

  void *& std::ios_base::pword (int __ix) [inline], [inherited]

Access to void pointer array.

Parameters
    __ix Index into the array.

Returns
    A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

  template<typename _CharT , typename _Traits , typename _Alloc > __stringbuf_type * std::basic_stringstream< _CharT, _Traits, _Alloc >::rdbuf () const [inline]

Accessing the underlying buffer.

Returns
    The current basic_stringbuf buffer.

This hides both signatures of std::basic_ios::rdbuf().

  template<typename _CharT , typename _Traits > basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf (basic_streambuf< _CharT, _Traits > * __sb) [inherited]

Changing the underlying buffer.

Parameters
    __sb The new stream buffer.

Returns
    The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument rdbuf(), which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

std::fstream     foo;         // or some other derived type
std::streambuf*  p = .....;

foo.ios::rdbuf(p);            // ios == basic_ios<char>

  template<typename _CharT , typename _Traits > iostate std::basic_ios< _CharT, _Traits >::rdstate () const [inline], [inherited]

Returns the error state of the stream buffer.

Returns
    A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Referenced by std::basic_ios< _CharT, _Traits >::bad(), std::basic_ios< _CharT, _Traits >::eof(), std::basic_ios< _CharT, _Traits >::fail(), std::basic_ios< _CharT, _Traits >::good(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ios< _CharT, _Traits >::setstate(), and std::basic_istream< _CharT, _Traits >::unget().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::read (char_type * __s, streamsize __n) [inherited]

Extraction without delimiters.

Parameters
    __s A character array.
    __n Maximum number of characters to store.

Returns
    *this

If the stream state is good(), extracts characters and stores them into __s until one of the following happens:

•   __n characters are stored

•   the input sequence reaches end-of-file, in which case the error state is set to failbit|eofbit.

Note
    This function is not overloaded on signed char and unsigned char.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::badbit, std::ios_base::eofbit, std::ios_base::failbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > streamsize std::basic_istream< _CharT, _Traits >::readsome (char_type * __s, streamsize __n) [inherited]

Extraction until the buffer is exhausted, but no more.

Parameters
    __s A character array.
    __n Maximum number of characters to store.

Returns
    The number of characters extracted.

Extracts characters and stores them into __s depending on the number of characters remaining in the streambuf's buffer, rdbuf()->in_avail(), called A here:

•   if A == -1, sets eofbit and extracts no characters

•   if A == 0, extracts no characters

•   if A > 0, extracts min(A,n)

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

References std::basic_istream< _CharT, _Traits >::_M_gcount, and std::ios_base::goodbit.

  void std::ios_base::register_callback (event_callback __fn, int __index) [inherited]

Add the callback __fn with parameter __index.

Parameters
    __fn The function to add.
    __index The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg (off_type __off, ios_base::seekdir __dir) [inherited]

Changing the current read position.

Parameters
    __off A file offset object.
    __dir The direction in which to seek.

Returns
    *this

If fail() is not true, calls rdbuf()->pubseekoff(__off,__dir). If that function fails, sets failbit.

Note
    This function first clears eofbit. It does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::in, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg (pos_type __pos) [inherited]

Changing the current read position.

Parameters
    __pos A file position object.

Returns
    *this

If fail() is not true, calls rdbuf()->pubseekpos(__pos). If that function fails, sets failbit.

Note
    This function first clears eofbit. It does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::in, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::seekp (off_type __off, ios_base::seekdir __dir) [inherited]

Changing the current write position.

Parameters
    __off A file offset object.
    __dir The direction in which to seek.

Returns
    *this

If fail() is not true, calls rdbuf()->pubseekoff(off,dir). If that function fails, sets failbit.

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::out, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::seekp (pos_type __pos) [inherited]

Changing the current write position.

Parameters
    __pos A file position object.

Returns
    *this

If fail() is not true, calls rdbuf()->pubseekpos(pos). If that function fails, sets failbit.

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::failbit, std::ios_base::goodbit, std::ios_base::out, and std::basic_ios< _CharT, _Traits >::rdbuf().

  fmtflags std::ios_base::setf (fmtflags __fmtfl) [inline], [inherited]

Setting new format flags.

Parameters
    __fmtfl Additional flags to set.

Returns
    The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

  fmtflags std::ios_base::setf (fmtflags __fmtfl, fmtflags __mask) [inline], [inherited]

Setting new format flags.

Parameters
    __fmtfl Additional flags to set.
    __mask The flags mask for fmtfl.

Returns
    The previous format control flags.

This function clears mask in the format flags, then sets fmtfl & mask. An example mask is ios_base::adjustfield.

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::setstate (iostate __state) [inline], [inherited]

Sets additional flags in the error state.

Parameters
    __state The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

References std::basic_ios< _CharT, _Traits >::clear(), and std::basic_ios< _CharT, _Traits >::rdstate().

Referenced by std::basic_ostream< _CharT, _Traits >::flush(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), and std::basic_istream< _CharT, _Traits >::unget().

  template<typename _CharT , typename _Traits , typename _Alloc > __string_type std::basic_stringstream< _CharT, _Traits, _Alloc >::str () const [inline]

Copying out the string buffer.

Returns
    rdbuf()->str()

  template<typename _CharT , typename _Traits , typename _Alloc > void std::basic_stringstream< _CharT, _Traits, _Alloc >::str (const __string_type & __s) [inline]

Setting a new buffer.

Parameters
    __s The string to use as a new sequence.

Calls rdbuf()->str(s).

  template<typename _CharT , typename _Traits > int std::basic_istream< _CharT, _Traits >::sync (void) [inherited]

Synchronizing the stream buffer.

Returns
    0 on success, -1 on failure

If rdbuf() is a null pointer, returns -1.

Otherwise, calls rdbuf()->pubsync(), and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note
    This function does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

References std::ios_base::badbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

  static bool std::ios_base::sync_with_stdio (bool __sync = true) [static], [inherited]

Interaction with the standard C I/O objects.

Parameters
    __sync Whether to synchronize or not.

Returns
    True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits >::pos_type std::basic_istream< _CharT, _Traits >::tellg (void) [inherited]

Getting the current read position.

Returns
    A file position object.

If fail() is not false, returns pos_type(-1) to indicate failure. Otherwise returns rdbuf()->pubseekoff(0,cur,in).

Note
    This function does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount(). At variance with putback, unget and seekg, eofbit is not cleared first.

References std::ios_base::badbit, std::ios_base::cur, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::in, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits >::pos_type std::basic_ostream< _CharT, _Traits >::tellp () [inherited]

Getting the current write position.

Returns
    A file position object.

If fail() is not false, returns pos_type(-1) to indicate failure. Otherwise returns rdbuf()->pubseekoff(0,cur,out).

References std::ios_base::badbit, std::ios_base::cur, std::basic_ios< _CharT, _Traits >::fail(), std::ios_base::out, and std::basic_ios< _CharT, _Traits >::rdbuf().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::tie () const [inline], [inherited]

Fetches the current tied stream.

Returns
    A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, std::cin is tied to std::cout.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::tie (basic_ostream< _CharT, _Traits > * __tiestr) [inline], [inherited]

Ties this stream to an output stream.

Parameters
    __tiestr The output stream.

Returns
    The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

  template<typename _CharT , typename _Traits > basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::unget (void) [inherited]

Unextracting the previous character.

Returns
    *this

If rdbuf() is not null, calls rdbuf()->sungetc(c).

If rdbuf() is null or if sungetc() fails, sets badbit in the error state.

Note
    This function first clears eofbit. Since no characters are extracted, the next call to gcount() will return 0, as required by DR 60.

References std::basic_istream< _CharT, _Traits >::_M_gcount, std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::eofbit, std::ios_base::goodbit, std::basic_ios< _CharT, _Traits >::rdbuf(), std::basic_ios< _CharT, _Traits >::rdstate(), and std::basic_ios< _CharT, _Traits >::setstate().

  void std::ios_base::unsetf (fmtflags __mask) [inline], [inherited]

Clearing format flags.

Parameters
    __mask The flags to unset.

This function clears __mask in the format flags.

  template<typename _CharT , typename _Traits > char_type std::basic_ios< _CharT, _Traits >::widen (char __c) const [inline], [inherited]

Widens characters.

Parameters
    __c The character to widen.

Returns
    The widened character.

Maps a character of char to a character of char_type.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Referenced by std::basic_ios< _CharT, _Traits >::fill().

  streamsize std::ios_base::width () const [inline], [inherited]

Flags access.

Returns
    The minimum field width to generate on output operations.

Minimum field width refers to the number of characters.

  streamsize std::ios_base::width (streamsize __wide) [inline], [inherited]

Changing flags.

Parameters
    __wide The new width value.

Returns
    The previous value of width().

  template<typename _CharT , typename _Traits > basic_ostream< _CharT, _Traits > & std::basic_ostream< _CharT, _Traits >::write (const char_type * __s, streamsize __n) [inherited]

Character string insertion.

Parameters
    __s The array to insert.
    __n Maximum number of characters to insert.

Returns
    *this

Characters are copied from __s and inserted into the stream until one of the following happens:

•   __n characters are inserted

•   inserting into the output sequence fails (in this case, badbit will be set in the stream's error state)

Note
    This function is not overloaded on signed char and unsigned char.

  static int std::ios_base::xalloc () [static], [inherited]

Access to unique indices.

Returns
    An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

Member Data Documentation

  template<typename _CharT , typename _Traits > streamsize std::basic_istream< _CharT, _Traits >::_M_gcount [protected], [inherited]
The number of characters extracted in the previous unformatted function; see gcount().

Referenced by std::basic_istream< char >::sentry::sentry(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< char >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< char >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< char >::seekg(), std::basic_istream< char >::seekg(), std::basic_istream< _CharT, _Traits >::unget(), and std::basic_istream< char >::unget().

  const fmtflags std::ios_base::adjustfield [static], [inherited]

A mask of left|right|internal. Useful for the 2-arg form of setf.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::internal(), std::left(), and std::right().

  const openmode std::ios_base::app [static], [inherited]

Seek to end before each write.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

  const openmode std::ios_base::ate [static], [inherited]

Open and seek to end immediately after opening.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

  const iostate std::ios_base::badbit [static], [inherited]

Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_ios< _CharT, _Traits >::bad(), std::basic_ios< _CharT, _Traits >::fail(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< char >::get(), std::basic_istream< char >::ignore(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_istream< _CharT, _Traits >::unget().

  const fmtflags std::ios_base::basefield [static], [inherited]

A mask of dec|oct|hex. Useful for the 2-arg form of setf.

Referenced by std::dec(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::hex(), and std::oct().

  const seekdir std::ios_base::beg [static], [inherited]

Request a seek relative to the beginning of the stream.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekpos().

  const openmode std::ios_base::binary [static], [inherited]

Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary.

Referenced by std::basic_filebuf< _CharT, _Traits >::showmanyc().

  const fmtflags std::ios_base::boolalpha [static], [inherited]

Insert/extract bool in alphabetic rather than numeric format.

Referenced by std::boolalpha(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::noboolalpha().

  const seekdir std::ios_base::cur [static], [inherited]

Request a seek relative to the current position within the sequence.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

  const fmtflags std::ios_base::dec [static], [inherited]

Converts integer input or generates integer output in decimal base.

Referenced by std::dec().

  const seekdir std::ios_base::end [static], [inherited]

Request a seek relative to the current end of the sequence.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

  const iostate std::ios_base::eofbit [static], [inherited]

Indicates that an input operation reached the end of an input sequence.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_istream< char >::sentry::sentry(), std::time_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ios< _CharT, _Traits >::eof(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< char >::getline(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< char >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

  const iostate std::ios_base::failbit [static], [inherited]

Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ios< _CharT, _Traits >::fail(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< char >::getline(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< char >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), and std::basic_ostream< _CharT, _Traits >::seekp().

  const fmtflags std::ios_base::fixed [static], [inherited]

Generate floating-point output in fixed-point notation.

Referenced by std::fixed(), and std::hexfloat().

  const fmtflags std::ios_base::floatfield [static], [inherited]

A mask of scientific|fixed. Useful for the 2-arg form of setf.

Referenced by std::defaultfloat(), std::fixed(), std::hexfloat(), and std::scientific().

  const iostate std::ios_base::goodbit [static], [inherited]

Indicates all is well.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::time_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< char >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< char >::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), and std::basic_istream< _CharT, _Traits >::unget().

  const fmtflags std::ios_base::hex [static], [inherited]

Converts integer input or generates integer output in hexadecimal base.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::hex().

  const openmode std::ios_base::in [static], [inherited]

Open for input. Default for ifstream and fstream.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

  const fmtflags std::ios_base::internal [static], [inherited]

Adds fill characters at a designated internal point in certain generated output, or identical to right if no such point is designated.

Referenced by std::internal().

  const fmtflags std::ios_base::left [static], [inherited]

Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.)

Referenced by std::num_put< _CharT, _OutIter >::do_put(), and std::left().

  const fmtflags std::ios_base::oct [static], [inherited]

Converts integer input or generates integer output in octal base.

Referenced by std::oct().

  const openmode std::ios_base::out [static], [inherited]

Open for output. Default for ofstream and fstream.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

  const fmtflags std::ios_base::right [static], [inherited]

Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.)

Referenced by std::right().

  const fmtflags std::ios_base::scientific [static], [inherited]

Generates floating-point output in scientific notation.

Referenced by std::hexfloat(), and std::scientific().

  const fmtflags std::ios_base::showbase [static], [inherited]

Generates a prefix indicating the numeric base of generated integer output.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::noshowbase(), and std::showbase().

  const fmtflags std::ios_base::showpoint [static], [inherited]

Generates a decimal-point character unconditionally in generated floating-point output.

Referenced by std::noshowpoint(), and std::showpoint().

  const fmtflags std::ios_base::showpos [static], [inherited]

Generates a + sign in non-negative generated numeric output.

Referenced by std::noshowpos(), and std::showpos().

  const fmtflags std::ios_base::skipws [static], [inherited]

Skips leading white space before certain input operations.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::noskipws(), std::__detail::operator>>(), and std::skipws().

  const openmode std::ios_base::trunc [static], [inherited]

Truncate an existing stream when opening. Default for ofstream.

  const fmtflags std::ios_base::unitbuf [static], [inherited]

Flushes output after each output operation.

Referenced by std::nounitbuf(), and std::unitbuf().

  const fmtflags std::ios_base::uppercase [static], [inherited]

Replaces certain lowercase letters with their uppercase equivalents in generated output.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::nouppercase(), and std::uppercase().

Author

Generated automatically by Doxygen for libstdc++ from the source code.